import { ReactElement } from "react";
import { GridColumns } from "@mui/x-data-grid-pro";
declare type commonProps = {
    rows: object[];
    columns: GridColumns;
    columnsVisibility?: {
        [key: string]: boolean;
    };
    onSelect?: (selectedRows: {
        [key: string]: unknown;
    }[]) => void;
    apiExportEndpoint?: string;
    defaultSelectRowID?: number;
    createNewButton?: JSX.Element;
    initialRowsPerPage?: 10 | 50 | 100;
};
declare type paginationFilterProps = {
    hidePagination?: false;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination: true;
    hideFilters: true;
    culumnsMatchingFilterName?: Map<string, string>;
    getRows?: (body: Record<string, unknown>) => void;
    requestPending?: boolean;
    queryParams?: Record<string, string>;
    setQueryparams?: (query: Record<string, unknown>) => void;
    networkCompletionStack?: Record<string, boolean>[];
} | {
    hidePagination: true;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination?: false;
    hideFilters: true;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName?: never;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
};
declare type editableProps = {
    editable: true;
    updateRow: (row: unknown) => void;
    deleteRow: (id: number) => void;
    deleteSelectedRows: (ids: number[]) => void;
} | {
    editable?: false;
    updateRow?: (row: unknown) => void;
    deleteRow?: (id: number) => void;
    deleteSelectedRows?: (ids: number[]) => void;
};
declare type propsType = commonProps & paginationFilterProps & editableProps;
/**
 * NerdDataGrid component.
 *
 * @param {propsType} props NerdDataGrid props.
 * @returns {ReactElement} DataGrid wrapper with server-side filters.
 */
declare function NerdDataGrid(props: propsType): ReactElement;
export default NerdDataGrid;
